/* 
groundwater_preproc.c
calculate GWD, CFD, GWeff, CFeff in function of GWD

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
Biome-BGCMuSo v7.0.
Copyright 2022, D. Hidy [dori.hidy@gmail.com]
Hungarian Academy of Sciences, Hungary
See the website of Biome-BGCMuSo at http://nimbus.elte.hu/bbgc/ for documentation, model executable and example input files.
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "ini.h"
#include "bgc_struct.h"
#include "pointbgc_struct.h"
#include "pointbgc_func.h"
#include "bgc_constants.h"
#include "bgc_func.h"


int groundwater_calculations(control_struct* ctrl, const siteconst_struct* sitec, const groundwaterINIT_struct* GWS, soilprop_struct* sprop, soilInfo_struct* soilInfo, epvar_struct* epv,
	                     wstate_struct* ws, wflux_struct* wf, cstate_struct* cs, nstate_struct* ns)
{
	int errorCode = 0;


	if (!errorCode && groundwater_preproc(ctrl, sitec, GWS, sprop, soilInfo, ws, wf))
	{
		printf("\n");
		printf("ERROR in groundwater_preproc.c for groundwater_calculation.c\n");
		errorCode = 1;
	}

	if (sprop->GWlayer != DATA_GAP && sprop->GWD != sprop->GWD_pre)
	{

		if (!errorCode && groundwater_movement(sitec, sprop, epv, soilInfo, ws, wf, cs, ns))
		{
			printf("\n");
			printf("ERROR in groundwater_movement.c for groundwater_calculation.c\n");
			errorCode = 1;
		}
	}
	

	return (errorCode);
}
